<?php /*dbaccess*/
/*Copyright 2011, 2013 by Michael Harris, http://next-nexus.info/
This file is part of NN Thesaurus Generator.

    NN Thesaurus Generator is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NN Thesaurus Generator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with NN Thesaurus Generator.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Connect to the database.  
 *
 * This will connect to the database wehn given a user (udb), password (pdb) and database to access.
 * Server is optional, and defaults to localhost.
 * It returns the link that is provided, or will throw an error and the program will die.
 * That's probably a bad idea, yes?
 * @param string $udb database user
 * @param string $pdb password for database user
 * @param string $database database to connect to
 * @param string $server where the database is located, defaults to 'localhost' and isn't required.
 * @return link to the database.
 * @TODO make it return something on error, rather than dieing. 
 *
 */
function access_db($udb,$pdb,$database,$server='localhost')
{
	$link = mysql_connect($server,$udb,$pdb);
	@mysql_select_db($database,$link) or die('unable to connect to database, in '.__FILE__.' at '.__LINE__);
	return $link;
}
/**
 * Simply closes the database when given a link.
 *
 * @param object $link the link to close.
 * @return mysql_insert_id() on success, false on failure. 
 *
 */
function close_db($link)
{
	return mysql_close($link);
}
function insert_entry($table,$term,$type,$useORbt,$scope,$note,$rt)//add
{
	$term=dbescapequotes($term); $type=dbescapequotes($type); $useORbt=dbescapequotes($useORbt); $scope=dbescapequotes($scope); $note=dbescapequotes($note); $rt=dbescapequotes($rt); 
	$query = "INSERT INTO $table VALUES ('','$term',$type,'$useORbt','$scope','$note','$rt')";
	if (!mysql_query($query)) 
	{
		$temp = mysql_error();
		if (substr($temp,0,15)=='Duplicate entry')
		{
			echo '<p class="error">A term with <a href="single.php?term='.$term.'">the name '.$term.'</a> already exists.</p>';
			return false;
		}
		echo 'The query '.__LINE__.': <br><em>'.$query.'</em><br> failed. The error message returned was <br><em>'.$temp.'</em><br> Please examine this problem, probably look in the code...';
		die();
	}
	$mysql_insert_id_dude=mysql_insert_id();
	make_related($table, $mysql_insert_id_dude,explode(DELIM,$rt));//tabe, id, rt
	return $mysql_insert_id_dude;
}
/**
* Make related, will update entries so that they have a relationship with the id provided
*
* given an id, and a DELIM separated list of other ids, will update all the ids in the list, to have a relationship to the original id.
*
* @param $table string the table to update.
* @param $id int the id we want the other entries to point to
* @param $rt string the DELIM separated ids that will be updated to point to $id, assumed to be DB safe.
*/
function make_related($table,$id,$rt)
{
//	echo count($rt).'f-';

	for ($ii=0;$ii<count($rt);$ii++)//
	{
//		echo $rt[$ii]."-\n";
		$list=$id;
		if ($rt[$ii] != 0)
		{
			$t2 = get_single_entry($table,$rt[$ii]);
//			print_r($t2);
			$temp3 = explode(DELIM,$t2['relatedterms']);
//			print_r($temp3);
			foreach ($temp3 as $temp4)
			{
				if ($temp4 != '' && $temp4!='0') {$list .= ','.$temp4;}
			}
			update_entry($table,$t2['id'],$t2['term'],$t2['type'],$t2['useORbt'],$t2['scope'],$t2['note'],$list,true);
		}
	}//*/

}
/**

* TODO fix this so it works?!
*/
function get_related()
{
return false;
}
/**
*
* @param $table the table to be used
* @param how the results should be sorted
* @param the format of the list, options include: anchorlist (default) list items with an anchor to the single.php entry; optionlist, formated in HTML option format.
* @param which, if any, option should be selected or highlighted, should be the term ID.
* @param $showall if true, will show all terms, even non preferred ones
* @returns a list of all terms, with formating as indicated
*
* TODO fix this, so that if showall is false, and there are no other entries, to give the "there are, at present, no entries" text. But maybe make it "no valid" or "only non-preferred"
*/
function list_all_entry($table,$orderby='term ASC', $format='anchorlist',$selected='',$showall=true)
{
	$query = "SELECT * FROM `$table`";
	$query = $query.' ORDER BY '.dbescapequotes($orderby).'';

	$result=mysql_query($query) or die (mysql_error() . "<br>\n".__LINE__.' '.__FILE__."<br>\n" . $query); 
	$numrows=num_rows($result);
	$ret = "\n";
	if ($numrows==0)
	{
		$term[0] =  "there are, at present, no entries";
		$value[0]= '0';
		$type[0]='';
	}
	else
	{
		$term[0] =  " -- none (".TERMISZERO.") -- ";
		$value[0]= '0';
		$type[0]='';
		for ($ii=1;$ii<$numrows+1;$ii++)
		{
			$item= fetch_array($result);
			$term[$ii] = $item['term'];
			$value[$ii]=$item['id'];
			$type[$ii]='';
			if ($item['type']==9)
			{
				$type[$ii]='*';
			} 
			else 
			{
				$type[$ii]='';
			}
		}
	}
	$ret =$ret."\n";
	for ($ii=0;$ii<count($term);$ii++)
	{
		if ($showall or $type[$ii]=='')//if show all, or if the type is preferred (not a star)
		{
		switch ($format)
		{
			case 'anchorlist':
				$ret=$ret.'<li><a href="single.php?id='.$value[$ii].'">'.$term[$ii].'</a>'.$type[$ii]."\n";
			break;
			case 'optionlist':
				$ret=$ret.'<option value="'.$value[$ii].'"';
				if ($value[$ii]==$selected){$ret=$ret.' selected';}
				$ret = $ret.'>'.$term[$ii].' '.$type[$ii].'</option>'."\n";
			break;
		}
		}
	}
	return $ret;
}
/**
* This will display all entries in a table format. 
*
*/
function display_all_entry($table,$haveNote=false,$orderby='',$showadmin=false,$showID=true)
{
	$query = "SELECT * FROM `$table`";
	if ($orderby!='')
	{
		$query = $query.' ORDER BY '.dbescapequotes($orderby).'';
	}
	$result=mysql_query($query) or die (mysql_error() . "<br>\n".__LINE__.' '.__FILE__."<br>\n" . $query); 
	$numrows=num_rows($result);

	if ($numrows==0)
	{
		echo "<p>there are, at present, no entries</p>";
	}
	else
	{//id	term	type	useORbt	scope	note	relatedterms
		$t= '<table border=1>'."\n\t".'<thead><tr>';
		$an='<a href="use_it.php?table=true&';
		if ($showID){$t .='<th>ID '.$an.'c=id&amp;o=ASC">▴</a> '.$an.'c=id&amp;o=DESC">▾</a></th>';}
		$t.='<th>'.TERM.$an.'c=term&amp;o=ASC">▴</a> '.$an.'c=term&amp;o=DESC">▾</a></th> <th><!-- '.$an.'c=useORbt&amp;o=ASC">▴</a> '.$an.'c=useORbt&amp;o=DESC">▾</a>use/BT--></th><th>'.UF.'</th><th>'.NT.'s</th><th>'.SCOPE.'</th><th>'.RT.'s</th>';
		if ($haveNote){$t=$t.'<th>'.NOTE.'</th>';}
		if ($showadmin){$t=$t.'<th>admin</th>';}
		$t=$t.'</tr></thead>'."\n\t<tbody>";
		for ($y=0;$y<$numrows;$y++)
		{
			$items= fetch_array($result);
			$row= "\n\t\t".'<tr>';
			if ($showID){$row.='<td>'.$items['id'].'</td>';}
			$row.='<td><a href="single.php?id='.$items['id'].'">'.htmlspecialchars($items['term']).'</a></td><td>';
			if ($items['type']==0){$row=$row.BT;} elseif($items['type']==9){$row=$row.USEI;}
			$temp = get_single_entry($table,$items['useORbt']);
			$row=$row.': <a href="single.php?id='.$temp['id'].'">'.$temp['term'].'</a></td>';

			$row = $row.'<td>'.get_use_for($table,$items['id'],9,'list').'</td>';// Use For

			$row = $row.'<td>'.get_use_for($table,$items['id'],0,'list').'</td>';// Narrower Terms
			$row = $row.'<td>'.$items['scope'].'</td>';//scope note

			$row=$row.'<td>';// related terms
			{$temp = explode(DELIM,$items['relatedterms']);}
			if ($temp[0]!='')//explode will always return something, even if it's nothing...
			{
				$row=$row.'<ul>';
				for ($xx=0;$xx<count ($temp);$xx++)
				{
					$t2 = get_single_entry($table,$temp[$xx]);
					$row=$row.'<li><a href="single.php?id='.$t2['id'].'">'.$t2['term'].'</a></li>';
				}
				$row=$row.'</ul>';
			}
			$row=$row.'</td>';

			if ($haveNote){$row=$row.'<td>'.$items['note'].'</td>';}
			if ($showadmin){$row=$row.'<td><a href="use_it.php?id='.$items['id'].'&amp;editme=true#form">edit</a>/<a href="delete.php?id='.$items['id'].'">delete</a></td>';}
			$t=$t.$row;
		}
		$t=$t."\n\t</tbody>\n</table>";
		echo $t;
	}
}
/**
* will remove all space and punctuation so that string can be used as html id.
*/
function removeallspaceandstuff($oldstring)
{
	$newstring = preg_replace("/[^a-zA-Z\s]/", "", $oldstring);//remove all not alpha-char or whitespace
	$newstring = preg_replace("/[\s]/", "-", $newstring);//replace white space with -
	return $newstring;
}
/**
* will return all entries 
*/
function display_all_entry2($table,$haveNote=false,$orderby='term ASC',$showadmin=false,$showID=false)
{
	$query = "SELECT * FROM `$table`";
	if ($orderby!='')
	{
		$query = $query.' ORDER BY '.dbescapequotes($orderby).'';
	}
	$result=mysql_query($query) or die (mysql_error() . "<br>\n".__LINE__.' '.__FILE__."<br>\n" . $query); 
	$numrows=num_rows($result);

	if ($numrows==0)
	{
		echo "<p>there are, at present, no entries</p>";
	}
	else
	{//id	term	type	useORbt	scope	note	relatedterms
		$t= '<div>'."\n\t".'';

		for ($y=0;$y<$numrows;$y++)
		{
			$items= fetch_array($result);
			$row= "\n\t\t".'<div id="'.removeallspaceandstuff($items['term']).'">';
			if ($showID){$row.='<div>'.$items['id'].'</div>';}
			$row.='<h2>'.htmlspecialchars($items['term']).'</h2><div>';
			if ($items['type']==0){$row=$row.BT;} elseif($items['type']==9){$row=$row.USEI;}
			$temp = get_single_entry($table,$items['useORbt']);
			$row=$row.': <a href="#'.removeallspaceandstuff($temp['term']).'">'.$temp['term'].'</a></div>';
			if ($items['type']==0) 
			{// if preferred, show all that stuff
			//get_usebt_terms
			$row = $row.'<div>'.UF.': '.get_usebt_terms($table,$items['id'],9,'list',"#",true).'</div>';// Use For

			$row = $row.'<div>'.NT.': '.get_usebt_terms($table,$items['id'],0,'list',"#",true).'</div>';// Narrower Terms
			$row = $row.'<div>'.SCOPE.': '.htmlspecialchars($items['scope']).'</div>';//scope note

			$row=$row.'<div class="rt">'.RT.': ';// related terms
			{$temp = explode(DELIM,$items['relatedterms']);}
			if ($temp[0]!='')//explode will always return something, even if it's nothing...
			{
				$row=$row.'<ul>';
				for ($xx=0;$xx<count ($temp);$xx++)
				{
					$t2 = get_single_entry($table,$temp[$xx]);
					$row=$row.'<li><a href="#'.removeallspaceandstuff($t2['term']).'">'.$t2['term'].'</a></li>';
				}
				$row=$row.'</ul>';
			}
			$row=$row.'</div>';
			}// here we end if preferred

			if ($haveNote){$row=$row.'<div>'.htmlspecialchars($items['note']).'</div>';}
			if ($showadmin){$row=$row.'<div><a href="use_it.php?id='.$items['id'].'&amp;editme=true#form">edit</a>/<a href="delete.php?id='.$items['id'].'">delete</a></div>';}
			$t=$t.$row.'</div>';
		}
		$t=$t."\n\t</div>";
		echo $t;
	}
}

/**
* will return the number of rows in a db query result
*/
function num_rows($re)
{
	return mysql_num_rows($re);
}
/**
* will return the number of entries in a table, of type type.
*/
function num_entries($table,$type=-1)
{
	switch ($type)
	{
		case -1:
		default:
		$res = mysql_query("SELECT * FROM `$table`");
		break;
		case 0:
		case 9:
		$res = mysql_query("SELECT * FROM `$table` WHERE `type`=$type");
		break;
	}
	return num_rows($res);
}
/**
 * returns a single entry from the thesaurus
 * 
 * @param string $table the table to get the item from
 * @param int or string $item the row in the table to return
 * @param int if it is id, or term. 0 is id, 1 is term
 * @return mixed the result of the call
 */
function get_single_entry($table,$item,$idorterm=0)
{
	$item=dbescapequotes($item);
	if ($idorterm==0){$result = mysql_query("SELECT * FROM $table WHERE id='$item'");}
	elseif ($idorterm==1){$result = mysql_query("SELECT * FROM $table WHERE term='$item'");}
	return fetch_array($result);
}
function fetch_array($r,$t=MYSQL_BOTH)
{
	return mysql_fetch_array($r,$t);
}
function dbescapequotes($item)
{
	return mysql_real_escape_string($item);
}
/**
 * Delete entry! 
 *
 * Removes 
 * @param $entry int the id in the db that should be deleted
 * @param $tblname string the table...
 * @return boolean
 */
function delete_entry($tblname,$entry)
{
	/*
$coal=mysql_real_escape_string($_GET['deletenumber']);
$able=mysql_real_escape_string($_GET['abc']);*/

$query = "DELETE FROM `$tblname` WHERE `id` = ".dbescapequotes($entry)." LIMIT 1";
//echo '<p>'.$query.'</p>';
if (!mysql_query($query)) {return false;}
else {return true;}

}
/** Update Entry
 *
 * @param $tblname string the table name
 * @param $entrynum int the id of the row to update
 * @param $colname array of string the name of the column to update.
 * @param $break boolean if true, don't call make_related
 * @return the mysql_insert_id
 * 
 */
function update_entry($table,$id,$term,$type,$useORbt,$scope,$note,$relatedterms,$break=false)
{
	$query = "UPDATE `$table` SET ";
	$query=$query.'`term`'."= '".dbescapequotes($term)."', ";
	$query=$query.'`type`'."= '".dbescapequotes($type)."', ";
	$query=$query.'`useORbt`'."= '".dbescapequotes($useORbt)."', ";
	$query=$query.'`scope`'."= '".dbescapequotes($scope)."', ";
	$query=$query.'`note`'."= '".dbescapequotes($note)."', ";
	$query=$query.'`relatedterms`'."= '".dbescapequotes($relatedterms)."' ";
	$query=$query." WHERE `id` =".dbescapequotes($id)." LIMIT 1 ;";

	if (!mysql_query($query)) 
	{
		echo 'The query: (on line '.__LINE__.')<br><em>'.$query.'</em><br> failed. The error message returned was <br><em>'.mysql_error().'</em><br> Please examine this problem, probably look in the code...';
		die();
	}
	if (!$break) {make_related($table,$id,explode(DELIM,dbescapequotes($relatedterms)));}
	return mysql_insert_id();
}

/** 
* Really bad name for this... 
* @param $id id of row
* @param $table name
* @param $type which type  (use for or narrower)
* @param $format what format (list item, or what)
* @param $sa start of anchor
* @param $d Boolean if false, will have db id (a number), if true, html id compat term (only alpha and -)
* @return will return all the terms that have Use/BT set pointing at that id. The results will be given as list items <li></li>, with anchors to the individual terms.
**/
function get_use_for($a,$b,$c,$d,$e='',$f='')
{
	return get_usebt_terms($a,$b,$c,$d);//
}
function get_usebt_terms($table,$id,$type,$format='list',$sa='single.php?id=',$d=false)
{
	$id=dbescapequotes($id);
	$type=dbescapequotes($type);
	$result = mysql_query("SELECT * FROM $table WHERE type='$type' AND useORbt='$id'");
	$ret = '';
	while ($temp = fetch_array($result))
	{
		switch ($format)
		{
			case 'list':
			if ($d){$anch=removeallspaceandstuff($temp['term']);}else {$anch=$temp['id'];}
			$ret=$ret.'<li><a href="'.$sa.$anch.'">'.$temp['term'].'</a></li>';
			break;
		}
	}
	if ($format == 'list' && $ret!=''){$ret = '<ul>'.$ret.'</ul>';}
	if ($ret == ' ' ) {$ret ='';}
	return $ret;
}

/**
* This will return a hierarchy of terms, in list format. 
*
* @param $table, the table of course.
* @param $root number the id of what you want to show the descendent of, if 0, show all.
* @param $showall boolean if to show all terms (true) or only preferred terms (false)
* @return a html fragment
*
*/ // remember $this = $this.'that' == $this .= 'that'
function get_hierarchy($table,$root,$showall=false)
{
	$result= mysql_query("SELECT * FROM $table WHERE id=$root");
	$temp = fetch_array($result);
	$rootterm=$temp['term'];
	if ($root !=0){
	$ret = "\n".'<li><a href="single.php?id='.$root.'">'.$rootterm.'</a>'."\n";// here we have the root term.
	}
	else {	$ret = "\n".'<li>'.TERMISZERO."\n";
	}
	$result = mysql_query("SELECT * FROM $table WHERE type='0' AND useORbt='$root'");//we get all rows that have root as parent
	
	if (num_rows($result)>0)
	{
		$ret .= '<ul>';
		while ($temp = fetch_array($result))//we iterate through them.
		{
			$ret .=get_hierarchy($table,$temp['id']);//the id becomes key, and then we add 
		}
		$ret .= '</ul>'."\n";
	}
	else
	{
		$ret .='';
	}
	$ret .='</li>';
	if ($showall)//we also show the non-preferred terms
	{
		$result = mysql_query("SELECT * FROM $table WHERE type='9' AND useORbt='$root'");
		if (num_rows($result)>0)
		{
			while ($temp = fetch_array($result))//we iterate through them.
			{//non-preferred terms should not have a hierarchy anyway.
					$ret .='<li><a href="single.php?id='.$temp['id'].'">'.$temp['term'].'</a>*</li>';
			}
		}
	}
	
	
	return $ret;
	/*
	<ul><li>concepts</li>
	<ul><li>ideologies</li>
	<ul><li>anarchism</li>
	<li>Marxism</li>
	</ul>
	</ul>
	
	*/
}//*/
?>
