<?php 
/*Copyright 2011 by Michael Harris, http://next-nexus.info/
This file is part of NN Thesaurus Generator.

    NN Thesaurus Generator is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NN Thesaurus Generator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with NN Thesaurus Generator.  If not, see <http://www.gnu.org/licenses/>.
 */
include_once ('settings.php');
include_once ('dbaccess.php');
include_once ('head.php');
$link = access_db($dbuser,$dbpass,$dbname,$dbserver);
?>
<p>This thesaurus is a controlled vocabulary intended to cover the subject of elections and electoral process. It is intended to cover national and sub-national political and governmental elections, rather than international, corporate or similar elections. However, many of the terms will be relevant to these other elections. </p>

<p>The thesaurus is biased towards Australian terms, though with some modifications, it could be used in other contexts. (For example, felony disenfranchisement is a non-preferred term: though it is very common in many other countries, in Australia the term felony is no longer used by in laws or the courts.).</p>

<p>As it is a controlled vocabulary, of the ordinary, preferred terms, no two terms mean the same thing, and every term is unique.</p>
<h2>Types of terms</h2>
<p>There are two types of term, preferred (ordinary) and non-preferred. Non-preferred terms will indicate what preferred term should be used instead, using the notation Use. Non-preferred terms include synonyms, near synonyms, alternate spellings and similar.</p>
<h2>Other relatinships </h2>
<p>There are two other types of relationship. Hierarchical relationships (indicated by the notion BT and NT (broader term and narrower term) include links between more generic and more specific terms. Conceptually-related relationship (indicated by the notation RT (related terms) are used to indicate that the two terms are somehow related and maybe useful together. Non-preferred terms do not have these types of relationships. As well, terms may have a scope note (SN), which provides advice on use and/or a definition or clarification if needed. </p>

<p>Hierarchical and related relationship are reciprocal. That is, if term "A" indicates that term "B" is it's broad term, then term "B" obviously has a narrower term of term "A". Similarly, if term "C" indicates that term "D" is a related term, then term "D" will indicate that term "C" is a related term.</p>
<p>The following four terms highlight the three relationships. </p>
<pre>absentee ballot
BT: voting method
NT: postal ballot
RT: absentee voter

absentee voter
BT: voter
NT: overseas voter
RT: absentee ballot

postal ballot
BT: absentee ballot
UF :postal voting

postal voting
Use: postal ballot</pre>

<h2>Use of singular and plural for nouns</h2>
<p>The following indicate when a noun is in its plural or singular form.
<ul><li>Where it is a single thing, and would make, little sense to be listed in plural form, it is listed in singular form. For example, "single winner" (voting systems).
<li>Where a noun or noun phrase forms is most often used in the singular form, where the singular form is the usual name, it is listed singularly, for example, "secret ballot" and "Australian ballot".
<li>Uncountable nouns are listed in the singular form.
</ul> 

<h2>Use of punctuation</h2>
<p>No punctuation marks are used. Where normally a hyphen would be used, a space is used instead (for example, "non core" and "write in"). Where a single quote (inverted comma) would be used, it is simply removed (e.g. "womens suffrage"). Capitals are used for proper nouns only. It happens that only non-preferred terms have proper nouns.</p>

<h2>Other notes</h2>
<p>There is no poly-hierarchy in this thesaurus, that is, no term may have more than one broader term. There are also no non-preferred terms that will indicate two (or more) preferred terms that should be used together. </p>

<?php include ('foot.php');?>
